install 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (seleción express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (seleción avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (seleción del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 200)
  54. error="$type $codeNum:\tError interno (seleción de base de datos).\n"
  55. ;;
  56. 201)
  57. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 202)
  60. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  61. ;;
  62. 203)
  63. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  64. ;;
  65. 204)
  66. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  67. ;;
  68. 205)
  69. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  70. ;;
  71. 206)
  72. type="WARNING"
  73. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  74. ;;
  75. 207)
  76. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  77. ;;
  78. 208)
  79. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  80. ;;
  81. 209)
  82. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  83. ;;
  84. 210)
  85. type="WARNING"
  86. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  87. ;;
  88. 211)
  89. type="WARNING"
  90. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  91. ;;
  92. 212)
  93. error="$type $codeNum:\tImposible recargar base de datos.\n"
  94. ;;
  95. 800)
  96. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  97. ;;
  98. 801)
  99. error="$type $codeNum:\t'whiptail' no instalado.\n"
  100. ;;
  101. 802)
  102. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  103. ;;
  104. 803)
  105. error="$type $codeNum:\t'apt-get' no instalado.\n"
  106. ;;
  107. 804)
  108. error="$type $codeNum:\t'yum' no instalado.\n"
  109. ;;
  110. 805)
  111. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  112. ;;
  113. 806)
  114. error="$type $codeNum:\t'ufw' no instalado.\n"
  115. ;;
  116. 807)
  117. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  118. ;;
  119. 900)
  120. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  121. ;;
  122. 901)
  123. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  124. ;;
  125. 902)
  126. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  127. ;;
  128. *)
  129. error="ERROR 13:\tError interno (comprobación de errores)\n"
  130. exitNum=1
  131. codeNum=13
  132. ;;
  133. esac
  134. if [ $exitNum -ne 0 ];then
  135. printf "$error"
  136. if [ $type = "ERROR" ];then
  137. exit $codeNum
  138. fi
  139. fi
  140. unset error exitNum codeNum type
  141. }
  142. OSInfo() {
  143. #printf "Detectando SO..."
  144. OS=$(uname -s)
  145. if [ $OS = "Linux" ]; then
  146. OS="GNU/Linux"
  147. if [ -f /etc/os-release ]; then
  148. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  149. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  150. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  151. for i in $ID_LIKE; do
  152. #printf "$i\n"
  153. case $i in
  154. debian|ubuntu)
  155. debianOS=true
  156. break
  157. ;;
  158. rhel|fedora)
  159. rhelOS=true
  160. break
  161. ;;
  162. *)
  163. debianOS=false
  164. rhelOS=false
  165. ;;
  166. esac
  167. done
  168. elif [ -f /etc/debian-version ]; then
  169. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  170. DIST="Debian"
  171. REV=""
  172. ID_LIKE="debian"
  173. debianOS=true
  174. elif [ -f /etc/redhat-release ]; then
  175. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  176. DIST="Red-Hat"
  177. REV=""
  178. ID_LIKE="rhel"
  179. rhelOS=true
  180. else
  181. # Other Linux (No Soportado)
  182. DIST=""
  183. REV=""
  184. ID_LIKE=""
  185. fi
  186. else
  187. # UNIX, OS X, ... (No Soportado)
  188. DIST=$OS
  189. REV=""
  190. fi
  191. #printf " $OS $DIST $REV\n"
  192. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  193. }
  194. comprobarRoot() {
  195. comprobarError $(id -u) 800
  196. }
  197. comprobarDependencias() {
  198. # Comprobamos whiptail
  199. which whiptail > /dev/null 2>&1
  200. comprobarError $? 801
  201. # Comprobamos hostnamectl
  202. which hostnamectl > /dev/null 2>&1
  203. comprobarError $? 802
  204. if [ $debianOS = true ];then
  205. # Comprobamos apt-get
  206. which apt-get > /dev/null 2>&1
  207. comprobarError $? 803
  208. # Actualizamos base de datos del repositorio
  209. printf "Actualizando repositorio APT..."
  210. result=$(apt-get -q -y update)
  211. comprobarError $? 805 $result
  212. printf " OK.\n"
  213. # Comprobamos Firewall (ufw)
  214. which ufw > /dev/null 2>&1
  215. comprobarError $? 806
  216. fi
  217. if [ $rhelOS = true ]; then
  218. # Comprobamos yum
  219. which yum > /dev/null 2>&1
  220. comprobarError $? 804
  221. # Actualizamos base de datos del repositorio
  222. printf "Actualizando repositorio YUM..."
  223. result=$(yum -y makecache 2>&1)
  224. comprobarError $? 805 $result
  225. printf " OK.\n"
  226. # Comprobamos Firewall (firewall-cmd)
  227. which firewall-cmd > /dev/null 2>&1
  228. comprobarError $? 807
  229. fi
  230. }
  231. inicializarVariables() {
  232. debianOS=false
  233. rhelOS=false
  234. apacheOn=false
  235. nginxOn=false
  236. mySQLOn=false
  237. mariaDBOn=false
  238. phpOn=false
  239. mediaWikiOn=false
  240. moodleOn=false
  241. actualizacionesOn=false
  242. }
  243. instalacionExpress() {
  244. apacheOn=true
  245. mariaDBOn=true
  246. phpOn=true
  247. mediaWikiOn=true
  248. moodleOn=true
  249. actualizacionesOn=true
  250. }
  251. mostrarBienvenida() {
  252. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  253. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
  254. exit 1
  255. fi
  256. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
  257. comprobarError $? 1
  258. }
  259. mostrarExpress() {
  260. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  261. "Express" "Instalación rápida" ON \
  262. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  263. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  264. comprobarError $? 1
  265. case $express in
  266. Express)
  267. instalacionExpress
  268. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  269. ;;
  270. Avanzada)
  271. mostrarAvanzada
  272. ;;
  273. *)
  274. comprobarError 1 2
  275. ;;
  276. esac
  277. }
  278. mostrarAvanzada() {
  279. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  280. "WebServer" "Instalar servidor web http/https" ON \
  281. "Database" "Instalar una base de datos SQL" ON \
  282. "PHP" "Instala PHP7" ON \
  283. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  284. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  285. "Moodle" "Instalar campus virtual con Moodle" ON \
  286. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  287. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  288. comprobarError $? 1
  289. # Mejora: autodetección de componentes ya instalados
  290. for i in $componentes; do
  291. case $i in
  292. \"WebServer\")
  293. mostrarWebServer
  294. ;;
  295. \"Database\")
  296. mostrarDatabase
  297. ;;
  298. \"PHP\")
  299. phpOn=true
  300. ;;
  301. \"SSL/TLS\")
  302. # 2 Opciones: Let's Encrypt o Autofirmado
  303. ;;
  304. \"MediaWiki\")
  305. mediaWikiOn=true
  306. ;;
  307. \"Moodle\")
  308. moodleOn=true
  309. ;;
  310. \"Actualizaciones\")
  311. actualizacionesOn=true
  312. ;;
  313. *)
  314. comprobarError 1 3
  315. ;;
  316. esac
  317. done
  318. }
  319. mostrarWebServer() {
  320. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  321. "Apache" "Instalar el servidor web Apache2" ON \
  322. "Nginx" "Instalar el servidor web Nginx" OFF \
  323. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  324. comprobarError $? 1
  325. case $webServer in
  326. Apache)
  327. apacheOn=true
  328. ;;
  329. Nginx)
  330. nginxOn=true
  331. ;;
  332. *)
  333. comprobarError 1 100
  334. ;;
  335. esac
  336. # Otras opciones (FQDN)
  337. establecerFQDN
  338. }
  339. establecerFQDN() {
  340. while [ -z $hostname ]; do
  341. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  342. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  343. hostnamectl set-hostname $hostname
  344. else
  345. hostname=$(hostname)
  346. fi
  347. done
  348. #printf "\nHostname: $hostname\n"
  349. }
  350. instalarApache() {
  351. if [ $debianOS = true ];then
  352. result=$(apt-get -q -y install apache2 2>&1)
  353. comprobarError $? 101 $result
  354. elif [ $rhelOS = true ]; then
  355. result=$(yum -y install httpd 2>&1)
  356. comprobarError $? 101 $result
  357. else
  358. comprobarError 1 104
  359. fi
  360. }
  361. instalarNginx() {
  362. if [ $debianOS = true ];then
  363. result=$(apt-get -q -y install nginx 2>&1)
  364. comprobarError $? 102 $result
  365. elif [ $rhelOS = true ]; then
  366. # Hay que instalar primero otro repositorio
  367. result=$(yum -y install epel-release)
  368. comprobarError $? 103 $result
  369. result=$(yum -y install nginx 2>&1)
  370. comprobarError $? 102 $result
  371. else
  372. comprobarError 1 105
  373. fi
  374. }
  375. mostrarDatabase() {
  376. if [ $debianOS = true ]; then
  377. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  378. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  379. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  380. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  381. comprobarError $? 1
  382. case $database in
  383. MySQL)
  384. mySQLOn=true
  385. ;;
  386. MariaDB)
  387. mariaDBOn=true
  388. ;;
  389. *)
  390. comprobarError 1 200
  391. ;;
  392. esac
  393. elif [ $rhelOS = true ]; then
  394. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
  395. comprobarError $? 1
  396. mariaDBOn=true
  397. else
  398. comprobarError 1 200
  399. fi
  400. # Otras opciones (contraseña)
  401. leerSQLPasswd
  402. }
  403. leerSQLPasswd() {
  404. control=false
  405. error=""
  406. # Leemos la contreseña (stdin) y confirmamos
  407. while [ $control = false ]; do
  408. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  409. comprobarError $? 1
  410. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  411. comprobarError $? 1
  412. #printf "SQL Password 1: $sqlPasswd\n"
  413. #printf "SQL Password 2: $sqlPasswd2\n"
  414. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  415. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  416. elif [ $sqlPasswd != $sqlPasswd2 ];then
  417. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  418. else
  419. control=true
  420. fi
  421. done
  422. #printf "SQL Password: $sqlPasswd\n"
  423. unset control error sqlPasswd2
  424. }
  425. establecerSQLPasswd() {
  426. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  427. # Mejora: ¿Si ya tiene una contraseña asignada?
  428. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  429. if [ $? -eq 0 ];then
  430. # Establecemos contraseña del usuario root
  431. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" > /dev/null 2>&1
  432. comprobarError $? 207
  433. # Desactivamos acceso root desde el exterior (solo localhost)
  434. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" > /dev/null 2>&1
  435. comprobarError $? 208
  436. # Eliminamos todos los usuarios anónimos
  437. mysql -e "DELETE FROM mysql.user WHERE User=''" > /dev/null 2>&1
  438. comprobarError $? 209
  439. # Eliminamos bases de datos 'test'
  440. mysql -e "DROP DATABASE IF EXISTS test" > /dev/null 2>&1
  441. comprobarError $? 210
  442. # Eliminamos privilegios de la base de datos 'test'
  443. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" > /dev/null 2>&1
  444. comprobarError $? 211
  445. # Aplicamos los cambios
  446. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  447. comprobarError $? 212
  448. else
  449. comprobarError $? 206
  450. fi
  451. }
  452. instalarMySQL() {
  453. if [ $debianOS = true ];then
  454. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  455. comprobarError $? 201 $result
  456. elif [ $rhelOS = true ]; then
  457. # MySQL no disponible en RHEL. 2 opciones:
  458. # 1) Instalar un repositorio adicional
  459. # 2) No instalar MySQL en distribuciones RHEL
  460. comprobarError 1 205
  461. else
  462. comprobarError 1 203
  463. fi
  464. }
  465. instalarMariaDB() {
  466. if [ $debianOS = true ];then
  467. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  468. comprobarError $? 202 $result
  469. elif [ $rhelOS = true ]; then
  470. result=$(yum -y install mariadb-server mariadb 2>&1)
  471. comprobarError $? 202 $result
  472. else
  473. comprobarError 1 204
  474. fi
  475. }
  476. habilitarServicio() {
  477. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  478. # Intentamos con systemctl (SystemD)
  479. printf "Habilitando servicio $1"
  480. if [ $# -le 0 ];then
  481. comprobarError 1 900
  482. fi
  483. which systemctl > /dev/null 2>&1
  484. if [ $? -eq 0 ]; then
  485. printf " (SystemD)..."
  486. systemctl start $1 > /dev/null 2>&1
  487. comprobarError $? 901 $1
  488. systemctl enable $1 > /dev/null 2>&1
  489. comprobarError $? 902 $1
  490. else
  491. # Intentamos con service (Upstart)
  492. which service > /dev/null 2>&1
  493. if [ $? -eq 0 ]; then
  494. printf " (Upstart)..."
  495. service $1 start > /dev/null 2>&1
  496. comprobarError $? 901 $1
  497. else
  498. # Intentamos con init.d (SystemV)
  499. printf " (SystemV)..."
  500. /etc/init.d/$1 start > /dev/null 2>&1
  501. comprobarError $? 901 $1
  502. fi
  503. # Intentamos habilitar en el arranque (Upstart)
  504. which update-rc.d > /dev/null 2>&1
  505. if [ $? -eq 0 ];then
  506. update-rc.d $1 enable
  507. comprobarError $? 902 $1
  508. else
  509. # Intentamos habilitar en el arranque (SystemV)
  510. which chkconfig > /dev/null 2>&1
  511. if [ $? -eq 0 ];then
  512. chkconfig $1 on
  513. comprobarError $? 902 $1
  514. else
  515. # ¿Qué mas opciones nos quedan?
  516. comprobarError 1 902 $1
  517. fi
  518. fi
  519. fi
  520. # Mejora: comprobar si el servicio está funcionando
  521. printf " OK.\n"
  522. }
  523. # Comprobación del sistema e inicialización
  524. comprobarRoot
  525. inicializarVariables
  526. OSInfo
  527. comprobarDependencias
  528. # Bienvenida
  529. mostrarBienvenida
  530. # Selección de componentes (express vs avanzada)
  531. mostrarExpress
  532. # Pre-configuración
  533. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  534. # Instalación
  535. # FALTA: whiptail --gauge -> Más bonito
  536. # Servidor Web
  537. if [ $apacheOn = true ]; then
  538. printf "Instalando Web Server Apache..."
  539. instalarApache
  540. printf " OK.\n"
  541. elif [ $nginxOn = true ]; then
  542. printf "Instalando Web Server Nginx..."
  543. instalarNginx
  544. printf " OK.\n"
  545. fi
  546. # Base de Datos
  547. if [ $mySQLOn = true ]; then
  548. printf "Instalando Base de Datos MySQL..."
  549. instalarMySQL
  550. printf " OK.\n"
  551. elif [ $mariaDBOn = true ]; then
  552. printf "Instalando Base de Datos MariaDB..."
  553. instalarMariaDB
  554. printf " OK.\n"
  555. fi
  556. # PHP
  557. if [ $phpOn = true ]; then
  558. printf "Instalando PHP-7..."
  559. printf " OK.\n"
  560. fi
  561. # SSL/TLS
  562. # Falta por implementar
  563. # MediaWiki
  564. if [ $mediaWikiOn = true ]; then
  565. printf "Instalando MediaWiki..."
  566. printf " OK.\n"
  567. fi
  568. # Moodle
  569. if [ $moodleOn = true ]; then
  570. printf "Instalando Moodle..."
  571. printf " OK.\n"
  572. fi
  573. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  574. # Por ejemplo: para cambiar la contraseña de root en mysql
  575. # Configuración
  576. # Configuración Apache
  577. # Virtual Hosts
  578. # Configuración Database
  579. # Arrancar Base de Datos, establecer contraseña y configuración segura
  580. if [ $mySQLOn = true ];then
  581. habilitarServicio mysql
  582. establecerSQLPasswd
  583. fi
  584. if [ $mariaDBOn = true ];then
  585. habilitarServicio mariadb
  586. establecerSQLPasswd
  587. fi
  588. # Configuración PHP
  589. # cgi.fix_pathinfo=0
  590. # Configurar máximo de subida de archivos
  591. # Configuración MediWiki
  592. # Configuración Moodle
  593. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  594. # Añadir reglas del cortafuegos
  595. # Configuración SSL/TLS
  596. # Generar certificados
  597. # Configurar certificados
  598. # Configurar actualizaciones
  599. if [ $actualizacionesOn = true ]; then
  600. printf "Configurando actualizaciones automáticas..."
  601. # CRONTAB
  602. printf " OK.\n"
  603. fi
  604. # Autodestrucción
  605. {
  606. for i in $(seq 0 5 50); do
  607. sleep 0.1
  608. echo $i
  609. done
  610. } | whiptail --gauge "Autodestrucción..." 7 70 0
  611. {
  612. for i in $(seq 50 5 100); do
  613. sleep 0.1
  614. echo $i
  615. done
  616. } | whiptail --gauge "Autopulverización..." 7 70 50